/*
    CharityWorld: AllHappyDemandAgents.h
    Copyright (C) 2003  Macaulay Institute

    This file is part of CharityWorld, a simple agent-based model to
    demonstrate the effects of errors in floating point arithmetic on
    emergent outcomes.

    CharityWorld is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CharityWorld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/* 

This file contains the declaration for four classes:
HappyDemandAgent, ExtAvgHappyDemandAgent,
MeanHappyDemandAgent, and ExtMeanHappyDemandAgent.
They only differ on the class they inherit from.
The implementation of the methods that they override 
is exactly the same for both classes.
(A dodgy way of doing multiple inheritance )

*/

#import "AllSimpleDemandAgents.h"

/*

HappyDemandAgent.h

The HappyDemandAgent inherits from the SimpleDemandAgent. 
His criterion for deciding whom to ask to is different.

*/

@interface HappyDemandAgent: SimpleDemandAgent {
}

-(BOOL)askingCondition: (Agent *)nbr;

@end


/*

ExtAvgHappyDemandAgent.h

The ExtAvgHappyDemandAgent inherits from the ExtAvgSimpleDemandAgent.
His criterion for deciding whom to ask to is different.

*/

@interface ExtAvgHappyDemandAgent: ExtAvgSimpleDemandAgent {
}

-(BOOL)askingCondition: (Agent *)nbr;

@end

/*

MeanHappyDemandAgent.h

The MeanHappyDemandAgent inherits from the MeanSimpleDemandAgent.
His criterion for deciding whom to ask to is different.

*/

@interface MeanHappyDemandAgent: MeanSimpleDemandAgent {
}

-(BOOL)askingCondition: (Agent *)nbr;

@end


/*

ExtMeanHappyDemandAgent.h

The ExtMeanHappyDemandAgent inherits from the ExtMeanSimpleDemandAgent.
His criterion for deciding whom to ask to is different.

*/

@interface ExtMeanHappyDemandAgent: ExtMeanSimpleDemandAgent {
}

-(BOOL)askingCondition: (Agent *)nbr;

@end
