/*
    CharityWorld: AllSimpleSupplyAgents.h
    Copyright (C) 2003  Macaulay Institute

    This file is part of CharityWorld, a simple agent-based model to
    demonstrate the effects of errors in floating point arithmetic on
    emergent outcomes.

    CharityWorld is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CharityWorld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details. (LICENCE file in
    this directory.)

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Contact information:
      Gary Polhill,
      Macaulay Institute, Craigiebuckler, Aberdeen, AB15 8QH. United Kingdom
      g.polhill@macaulay.ac.uk
*/
/* 

This file contains the declaration for four classes:
SimpleSupplyAgent, ExtAvgSimpleSupplyAgent, 
MeanSimpleSupplyAgent, and ExtMeanSimpleSupplyAgent.
They only differ on the class they inherit from.
The implementation of the methods that they override 
is exactly the same for all the classes.
(A dodgy way of doing multiple inheritance )

*/

#import "SimpleAgent.h"
#import "ExtAvgSimpleAgent.h"
#import "MeanSimpleAgent.h"
#import "ExtMeanSimpleAgent.h"

@class DoubleSimple;

/*

SimpleSupplyAgent.h

The SimpleSupplyAgent inherits from the SimpleAgent, but never begs
and never responds to any begging.

*/

@interface SimpleSupplyAgent: SimpleAgent {
}

-step;
-ask;
-(void)respondTo: (Agent *)a askingFor: (DoubleSimple *)amount;
-(void)reschedule;

@end


/*

ExtAvgSimpleSupplyAgent.h

The ExtAvgSimpleSupplyAgent inherits from the ExtAvgSimpleAgent,
but never begs and never responds to any begging.

*/

@interface ExtAvgSimpleSupplyAgent: ExtAvgSimpleAgent {
}

-step;
-ask;
-(void)respondTo: (Agent *)a askingFor: (DoubleSimple *)amount;
-(void)reschedule;

@end


/*

MeanSimpleSupplyAgent.h

The MeanSimpleSupplyAgent inherits from the MeanSimpleAgent,
but never begs and never responds to any begging.

*/

@interface MeanSimpleSupplyAgent: MeanSimpleAgent {
}

-step;
-ask;
-(void)respondTo: (Agent *)a askingFor: (DoubleSimple *)amount;
-(void)reschedule;

@end

/*

ExtMeanSimpleSupplyAgent.h

The ExtMeanSimpleSupplyAgent inherits from the ExtMeanSimpleAgent,
but never begs and never responds to any begging.

*/

@interface ExtMeanSimpleSupplyAgent: ExtMeanSimpleAgent {
}

-step;
-ask;
-(void)respondTo: (Agent *)a askingFor: (DoubleSimple *)amount;
-(void)reschedule;

@end
